Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zrem.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 2528)
@@ -27,5 +27,6 @@
    PRIVATE
 
-   PUBLIC   p4z_rem    ! called in p4zbio.F90
+   PUBLIC   p4z_rem         ! called in p4zbio.F90
+   PUBLIC   p4z_rem_init    ! called in trcsms_pisces.F90
 
    !! * Shared module variables
@@ -41,18 +42,16 @@
      &                   denitr                     !: denitrification array
 
-   REAL(wp) ::   &
-     xstep            !: Time step duration for biology
 
    !!* Substitution
 #  include "top_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
 CONTAINS
 
-   SUBROUTINE p4z_rem(kt, jnt)
+   SUBROUTINE p4z_rem( kt )
       !!---------------------------------------------------------------------
       !!                     ***  ROUTINE p4z_rem  ***
@@ -62,5 +61,5 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt, jnt ! ocean time step
+      INTEGER, INTENT(in) ::   kt ! ocean time step
       INTEGER  ::   ji, jj, jk
       REAL(wp) ::   zremip, zremik , zlam1b
@@ -72,5 +71,5 @@
       REAL(wp) ::   zofer2, zdenom, zdenom2
 #endif
-      REAL(wp) ::   zlamfac, zonitr
+      REAL(wp) ::   zlamfac, zonitr, zstep
       REAL(wp), DIMENSION(jpi,jpj)     ::   ztempbac
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdepbac, zfesatur, zolimi
@@ -78,12 +77,4 @@
 
       !!---------------------------------------------------------------------
-
-
-      IF( ( kt * jnt ) == nittrc000  )  THEN
-         CALL p4z_rem_init                ! Initialization (first time-step only)
-         xstep = rfact2 / rday            ! Time step duration for the biology
-         nitrfac(:,:,:) = 0.0
-         denitr (:,:,:) = 0.0  
-      ENDIF
 
 
@@ -94,7 +85,7 @@
        ztempbac(:,:)   = 0.0
 
-!      Computation of the mean phytoplankton concentration as
-!      a crude estimate of the bacterial biomass
-!      --------------------------------------------------
+      !  Computation of the mean phytoplankton concentration as
+      !  a crude estimate of the bacterial biomass
+      !   --------------------------------------------------
 
       DO jk = 1, jpkm1
@@ -114,39 +105,33 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-
-!    DENITRIFICATION FACTOR COMPUTED FROM O2 LEVELS
-!    ----------------------------------------------
-
+               ! denitrification factor computed from O2 levels
                nitrfac(ji,jj,jk) = MAX(  0.e0, 0.4 * ( 6.e-6  - trn(ji,jj,jk,jpoxy) )    &
                   &                                / ( oxymin + trn(ji,jj,jk,jpoxy) )  )
-            END DO
-         END DO
-      END DO
-
-      nitrfac(:,:,:) = MIN( 1., nitrfac(:,:,:) )
-
-
-      DO jk = 1, jpkm1
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-
-!     DOC ammonification. Depends on depth, phytoplankton biomass
-!     and a limitation term which is supposed to be a parameterization
-!     of the bacterial activity. 
-!     ----------------------------------------------------------------
-               zremik = xremik * xstep / 1.e-6 * xlimbac(ji,jj,jk)         &
-# if defined key_off_degrad
-                  &            * facvol(ji,jj,jk)              &
+               nitrfac(ji,jj,jk) = MIN( 1., nitrfac(ji,jj,jk) )
+            END DO
+         END DO
+      END DO
+
+      DO jk = 1, jpkm1
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+# if defined key_degrad
+               zstep = xstep * facvol(ji,jj,jk)
+# else
+               zstep = xstep
 # endif
-                  &            * zdepbac(ji,jj,jk)
+               ! DOC ammonification. Depends on depth, phytoplankton biomass
+               !     and a limitation term which is supposed to be a parameterization
+               !     of the bacterial activity. 
+               zremik = xremik * zstep / 1.e-6 * xlimbac(ji,jj,jk) * zdepbac(ji,jj,jk) 
                zremik = MAX( zremik, 5.5e-4 * xstep )
 
-!     Ammonification in oxic waters with oxygen consumption
-!     -----------------------------------------------------
+               !     Ammonification in oxic waters with oxygen consumption
+               !     -----------------------------------------------------
                zolimi(ji,jj,jk) = MIN(  ( trn(ji,jj,jk,jpoxy) - rtrn ) / o2ut,  &
                   &                    zremik * ( 1.- nitrfac(ji,jj,jk) ) * trn(ji,jj,jk,jpdoc)  ) 
 
-!     Ammonification in suboxic waters with denitrification
-!     -------------------------------------------------------
+               !     Ammonification in suboxic waters with denitrification
+               !     -------------------------------------------------------
                denitr(ji,jj,jk) = MIN(  ( trn(ji,jj,jk,jpno3) - rtrn ) / rdenit,   &
                   &                     zremik * nitrfac(ji,jj,jk) * trn(ji,jj,jk,jpdoc)  )
@@ -167,22 +152,21 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-
-!    NH4 nitrification to NO3. Ceased for oxygen concentrations
-!    below 2 umol/L. Inhibited at strong light 
-!    ----------------------------------------------------------
-               zonitr  = nitrif * xstep * trn(ji,jj,jk,jpnh4) / ( 1.+ emoy(ji,jj,jk) )     &
-# if defined key_off_degrad
-                  &      * facvol(ji,jj,jk)              &
+# if defined key_degrad
+               zstep = xstep * facvol(ji,jj,jk)
+# else
+               zstep = xstep
 # endif
-                  &      * ( 1.- nitrfac(ji,jj,jk) )
-
-!
-!   Update of the tracers trends
-!   ----------------------------
-
-              tra(ji,jj,jk,jpnh4) = tra(ji,jj,jk,jpnh4) - zonitr
-              tra(ji,jj,jk,jpno3) = tra(ji,jj,jk,jpno3) + zonitr
-              tra(ji,jj,jk,jpoxy) = tra(ji,jj,jk,jpoxy) - o2nit * zonitr
-              tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) - rno3  * zonitr
+               !    NH4 nitrification to NO3. Ceased for oxygen concentrations
+               !    below 2 umol/L. Inhibited at strong light 
+               !    ----------------------------------------------------------
+               zonitr  = nitrif * zstep * trn(ji,jj,jk,jpnh4) / ( 1.+ emoy(ji,jj,jk) ) * ( 1.- nitrfac(ji,jj,jk) ) 
+
+               !   Update of the tracers trends
+               !   ----------------------------
+
+               tra(ji,jj,jk,jpnh4) = tra(ji,jj,jk,jpnh4) - zonitr
+               tra(ji,jj,jk,jpno3) = tra(ji,jj,jk,jpno3) + zonitr
+               tra(ji,jj,jk,jpoxy) = tra(ji,jj,jk,jpoxy) - o2nit * zonitr
+               tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) - rno3  * zonitr
 
             END DO
@@ -200,11 +184,11 @@
             DO ji = 1, jpi
 
-!    Bacterial uptake of iron. No iron is available in DOC. So
-!    Bacteries are obliged to take up iron from the water. Some
-!    studies (especially at Papa) have shown this uptake to be
-!    significant
-!    ----------------------------------------------------------
+               !    Bacterial uptake of iron. No iron is available in DOC. So
+               !    Bacteries are obliged to take up iron from the water. Some
+               !    studies (especially at Papa) have shown this uptake to be significant
+               !    ----------------------------------------------------------
                zbactfer = 15.e-6 * rfact2 * 4.* 0.4 * prmax(ji,jj,jk)           &
-                  &               * ( xlimphy(ji,jj,jk) * zdepbac(ji,jj,jk))**2           &
+                  &               * ( xlimphy(ji,jj,jk) * zdepbac(ji,jj,jk))           &
+                  &               * ( xlimphy(ji,jj,jk) * zdepbac(ji,jj,jk))           &
                   &                  / ( xkgraz2 + zdepbac(ji,jj,jk) )                    &
                   &                  * ( 0.5 + SIGN( 0.5, trn(ji,jj,jk,jpfer) -2.e-11 )  )
@@ -216,5 +200,4 @@
                tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zbactfer
 #endif
-
             END DO
          END DO
@@ -230,18 +213,18 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-
-!    POC disaggregation by turbulence and bacterial activity. 
-!    -------------------------------------------------------------
-               zremip = xremip * xstep * tgfunc(ji,jj,jk)   &
-# if defined key_off_degrad
-                  &            * facvol(ji,jj,jk)              &
+# if defined key_degrad
+               zstep = xstep * facvol(ji,jj,jk)
+# else
+               zstep = xstep
 # endif
-                  &            * ( 1.- 0.5 * nitrfac(ji,jj,jk) )
-
-!    POC disaggregation rate is reduced in anoxic zone as shown by
-!    sediment traps data. In oxic area, the exponent of the martin s
-!    law is around -0.87. In anoxic zone, it is around -0.35. This
-!    means a disaggregation constant about 0.5 the value in oxic zones
-!    -----------------------------------------------------------------
+               !    POC disaggregation by turbulence and bacterial activity. 
+               !    -------------------------------------------------------------
+               zremip = xremip * zstep * tgfunc(ji,jj,jk) * ( 1.- 0.5 * nitrfac(ji,jj,jk) ) 
+
+               !    POC disaggregation rate is reduced in anoxic zone as shown by
+               !    sediment traps data. In oxic area, the exponent of the martin s
+               !    law is around -0.87. In anoxic zone, it is around -0.35. This
+               !    means a disaggregation constant about 0.5 the value in oxic zones
+               !    -----------------------------------------------------------------
                zorem  = zremip * trn(ji,jj,jk,jppoc)
                zofer  = zremip * trn(ji,jj,jk,jpsfe)
@@ -253,6 +236,6 @@
 #endif
 
-!  Update the appropriate tracers trends
-!  -------------------------------------
+               !  Update the appropriate tracers trends
+               !  -------------------------------------
 
                tra(ji,jj,jk,jpdoc) = tra(ji,jj,jk,jpdoc) + zorem
@@ -282,21 +265,20 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-
-!     Remineralization rate of BSi depedant on T and saturation
-!     ---------------------------------------------------------
+# if defined key_degrad
+               zstep = xstep * facvol(ji,jj,jk)
+# else
+               zstep = xstep
+# endif
+               !     Remineralization rate of BSi depedant on T and saturation
+               !     ---------------------------------------------------------
                zsatur  = ( sio3eq(ji,jj,jk) - trn(ji,jj,jk,jpsil) ) / ( sio3eq(ji,jj,jk) + rtrn )
                zsatur  = MAX( rtrn, zsatur )
                zsatur2 = zsatur * ( 1. + tn(ji,jj,jk) / 400.)**4
                znusil  = 0.225  * ( 1. + tn(ji,jj,jk) / 15.) * zsatur + 0.775 * zsatur2**9
-#    if defined key_off_degrad
-               zsiremin = xsirem * xstep * znusil * facvol(ji,jj,jk)
-# else
-               zsiremin = xsirem * xstep * znusil
-#    endif
+               zsiremin = xsirem * zstep * znusil
                zosil = zsiremin * trn(ji,jj,jk,jpdsi)
 
                tra(ji,jj,jk,jpdsi) = tra(ji,jj,jk,jpdsi) - zosil
                tra(ji,jj,jk,jpsil) = tra(ji,jj,jk,jpsil) + zosil
-
                !
             END DO
@@ -317,24 +299,25 @@
 !CDIR NOVERRCHK
             DO ji = 1, jpi
-!
-!      Compute de different ratios for scavenging of iron
-!      --------------------------------------------------
+# if defined key_degrad
+               zstep = xstep * facvol(ji,jj,jk)
+# else
+               zstep = xstep
+# endif
+               !  Compute de different ratios for scavenging of iron
+               !  --------------------------------------------------
 
 #if  defined key_kriest
-                zdenom1 = trn(ji,jj,jk,jppoc) / &
+               zdenom1 = trn(ji,jj,jk,jppoc) / &
            &           ( trn(ji,jj,jk,jppoc) + trn(ji,jj,jk,jpdsi) + trn(ji,jj,jk,jpcal) + rtrn )
 #else
-                zdenom = 1. / ( trn(ji,jj,jk,jppoc) + trn(ji,jj,jk,jpgoc)  &
+               zdenom = 1. / ( trn(ji,jj,jk,jppoc) + trn(ji,jj,jk,jpgoc)  &
            &            + trn(ji,jj,jk,jpdsi) + trn(ji,jj,jk,jpcal) + rtrn )
 
-                zdenom1 = trn(ji,jj,jk,jppoc) * zdenom
-                zdenom2 = trn(ji,jj,jk,jpgoc) * zdenom
-#endif
-
-
-!     scavenging rate of iron. this scavenging rate depends on the
-!     load in particles on which they are adsorbed. The
-!     parameterization has been taken from studies on Th
-!     ------------------------------------------------------------
+               zdenom1 = trn(ji,jj,jk,jppoc) * zdenom
+               zdenom2 = trn(ji,jj,jk,jpgoc) * zdenom
+#endif
+               !  scavenging rate of iron. this scavenging rate depends on the load in particles
+               !  on which they are adsorbed. The  parameterization has been taken from studies on Th
+               !     ------------------------------------------------------------
                zkeq = fekeq(ji,jj,jk)
                zfeequi = ( -( 1. + zfesatur(ji,jj,jk) * zkeq - zkeq * trn(ji,jj,jk,jpfer) )               &
@@ -349,15 +332,10 @@
                   &                      + trn(ji,jj,jk,jpcal) + trn(ji,jj,jk,jpdsi)  ) * 1.e6
 #endif
-
-# if defined key_off_degrad
-               zscave = zfeequi * zlam1b * xstep  * facvol(ji,jj,jk)
-# else
-               zscave = zfeequi * zlam1b * xstep
-# endif
-
-!  Increased scavenging for very high iron concentrations
-!  found near the coasts due to increased lithogenic particles
-!  and let s say it unknown processes (precipitation, ...)
-!  -----------------------------------------------------------
+               zscave = zfeequi * zlam1b * zstep
+
+               !  Increased scavenging for very high iron concentrations
+               !  found near the coasts due to increased lithogenic particles
+               !  and let s say it unknown processes (precipitation, ...)
+               !  -----------------------------------------------------------
                zlamfac = MAX( 0.e0, ( gphit(ji,jj) + 55.) / 30. )
                zlamfac = MIN( 1.  , zlamfac )
@@ -374,9 +352,5 @@
 #endif
 
-# if defined key_off_degrad
-               zaggdfe = zlam1b * xstep * 0.5 * ( trn(ji,jj,jk,jpfer) - zfeequi ) * facvol(ji,jj,jk)
-# else
-               zaggdfe = zlam1b * xstep * 0.5 * ( trn(ji,jj,jk,jpfer) - zfeequi )
-# endif
+               zaggdfe = zlam1b * zstep * 0.5 * ( trn(ji,jj,jk,jpfer) - zfeequi )
 
                tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) - zscave - zaggdfe
@@ -400,6 +374,6 @@
        ENDIF
 
-!     Update the arrays TRA which contain the biological sources and sinks
-!     --------------------------------------------------------------------
+       !     Update the arrays TRA which contain the biological sources and sinks
+       !     --------------------------------------------------------------------
 
       DO jk = 1, jpkm1
@@ -429,5 +403,5 @@
       !!
       !! ** Method  :   Read the nampisrem namelist and check the parameters
-      !!      called at the first timestep (nittrc000)
+      !!      called at the first timestep
       !!
       !! ** input   :   Namelist nampisrem
@@ -452,9 +426,8 @@
       ENDIF
 
+      nitrfac(:,:,:) = 0.0
+      denitr (:,:,:) = 0.0  
+
    END SUBROUTINE p4z_rem_init
-
-
-
-
 
 #else
